import es, vecmath, gamethread

sh_maxdistance = es.ServerVar("sh_maxdistance", 100, "Maximum distance from the sentry gun to be able to hack it.")

sentryhack_version = es.ServerVar("sentryhack_version", 1.1)
sentryhack_version.makepublic()

def load():
    es.regclientcmd("+hack", "sentryhack/hack_sentry")
    es.regclientcmd("-hack", "sentryhack/hack_cancel")

def unload():
    es.unregclientcmd("+hack")
    es.unregclientcmd("-hack")

def hack_sentry():
    sh_userid = es.getcmduserid()
    if es.getplayerprop(sh_userid, "CTFPlayerResource.m_iPlayerClass") == "TF_SPY":
        sh_sentry = get_closest(sh_userid, es.createentitylist("obj_sentrygun"))
        if sh_sentry != None:
            sh_team = es.getplayerprop(sh_userid, "CTFPlayer.m_iTeamNum")
            sh_owner = es.getindexprop(sh_sentry, "CObjectSentryGun.m_hBuilder")
            sh_ownerteam = es.getplayerprop(sh_owner, "CTFPlayer.m_iTeamNum")
            if sh_team != sh_ownerteam:
                es.setindexprop(sh_sentry, "CObjectSentryGun.m_hBuilder", sh_userid)
            else:
                es.tell(sh_userid, "#multi", "#green[SentryGun] #defaultYou cannot hack ally sentry guns!")
        else:
            es.tell(sh_userid, "#multi", "#green[SentryGun] #defaultNo sentry guns in range!")
    else:
        es.tell(sh_userid, "#multi", "#green[SentryGun] #defaultOnly Spy's can hack sentry guns.")

def get_closest(sh_userid, sh_sentrylist):
    sh_sentry = None
    sh_distance = sh_maxdistance
    sh_userlocation = es.getplayerprop(sh_userid, "CBaseEntity.m_vecOrigin")
    for sh_entity in sh_sentrylist:
        sh_entitylocation = es.getindexprop(sh_entity, "CBaseEntity.m_vecOrigin")
        if vecmath.distance(sh_userlocation, sh_entitylocation) < sh_distance:
            sh_distance = vecmath.distance(sh_userlocation, sh_entitylocation)
            sh_sentry = sh_entity
    return sh_sentry

def do_hack(sh_userid, sh_sentry, sh_percentage=0):
    sh_percentage += 2
    hudhint(sh_userid, sh_percentage)
    sh_checksentry = get_closest(sh_userid, es.createentitylist("obj_sentrygun"))
    es.server.cmd('es_give %d env_spark' % int(sh_userid))
    es.server.cmd('es_fire %d env_spark setparent !activator' % int(sh_userid))
    es.server.cmd('es_fire %d env_spark addoutput "spawnflags 896"' % int(sh_userid))
    es.server.cmd('es_fire %d env_spark addoutput "angles -90 0 0"' % int(sh_userid))
    es.server.cmd('es_fire %d env_spark addoutput "magnitude 8"' % int(sh_userid))
    es.server.cmd('es_fire %d env_spark addoutput "traillength 3"' % int(sh_userid))
    es.server.cmd('es_fire %d env_spark startspark' % int(sh_userid))
    if sh_sentry == sh_checksentry:
        if sh_percentage >= 100:
            sh_name = es.getplayername(sh_userid)
            sh_owner = es.getindexprop(sh_sentry, "CObjectSentryGun.m_hBuilder")
            sh_ownername = es.getplayername(sh_owner)
            es.setindexprop(sh_sentry, "CObjectSentryGun.m_hBuilder", sh_userid)
            es.emitsound("entity", sh_entity, "weapons/sentry_scan3.wav", 1.0, 0.5)
            es.msg("#multi", "#green[SentryGun] #lightgreen%s#default has hacked #lightgreen%s's #defaultsentry gun and turned it on it's allies." % (sh_name, sh_ownername))
            es.server.cmd('es_fire %d env_spark stopspark' % int(sh_userid))
        else:
            gamethread.delayedname(0.1, "do_hack_" + str(sh_userid), do_hack, args=(sh_userid, sh_sentry, sh_percentage))
    else:
        hack_cancel(sh_userid)

def hack_cancel(sh_userid = None):
    if sh_userid == None:
        sh_userid = es.getcmduserid()
    gamethread.cancelDelayed("do_hack_" + str(sh_userid))
    es.server.cmd('es_fire %d env_spark stopspark' % int(sh_userid))

def hudhint(sh_userid, sh_percentage):
    sh_percentage = int(sh_percentage) / 5
    sh_blank = 20 - sh_percentage
    sh_text = "[" + "|"*sh_percentage + "-"*sh_blank + "]"
    es.usermsg('create','hudhint','HintText')
    es.usermsg('write','short','hudhint',-1)
    es.usermsg('write','string','hudhint',sh_text)
    es.usermsg('send','hudhint',sh_userid)
    es.usermsg('delete','hudhint')

def player_disconnect(event_var):
    hack_cancel(event_var["userid"])

def player_spawn(event_var):
    hack_cancel(event_var["userid"])

def player_death(event_var):
    hack_cancel(event_var["userid"])